/* quatern.cpp                                                  12/28/00

     Copyright (c) John R. Berryhill 1995 - 2000.  All Rights Reserved.

*/

#include "..\book\source\quatern.h"

quatern& quatern::operator*=( quatern& q)                    //$
{
    quatern tmp(*this);
    re = tmp.re*q.re - tmp.im*conj(q.im);
    im = tmp.re*q.im + tmp.im*conj(q.re);
    return *this;
}

#include <stdio.h>
#include <stdlib.h>

main()                        // Demonstration
{
   complex a (1., 0.); complex b (0., 1.);
   double deg = 45./atan(1.); double ang = 53.13 * 0.5;
   quatern X, Y;
   quatern A (a, b); quatern B (1., 1., 0., 0.);
   quatern C (a, a); quatern D (b, b);
   quatern zrot (cos(ang/deg), 0., 0., sin(ang/deg));   // clockwise

   cout << "====================\n";
   cout << A << B << C << D;

   X = D * C;  Y = C * D;
   cout << X << Y;
   printf("%g %g %g %g\n", norm(X), arg(X), norm(Y), arg(Y));

   A = conj(zrot)*=A*=zrot;
   B = conj(zrot)*=B*=zrot;
   C = conj(zrot)*=C*=zrot;
   D = conj(zrot)*=D*=zrot;
   cout << A << B << C << D << arg(zrot)*deg << "\n";
// WaitForIt();
   A *= inv(A); B *= inv(B); C *= inv(C); D *= inv(D);
   cout << A << B << C << D;
}
